/* GCC */

#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>

#define MAX_P 2000

using namespace std;

int n, m, k;
int length[MAX_P];
bool visited[MAX_P];
int roads[MAX_P][MAX_P];
int roads_from[MAX_P];
int stops[MAX_P];
int minim =  MAX_P;

int min_length(){
    for(int i = 0; i < k; i++){
        if(length[stops[i]] != MAX_P && length[stops[i]] != 0){
            return length[stops[i]];
        }
    }
}

bool is_value(int current){
    for(int  i = 0; i < k; i++){
        if(visited[stops[i]] && stops[i] != current){
            return true;
        }
    }
    return false;
}

void init(){
    freopen("hiking.in", "r", stdin);
    freopen("hiking.out", "w", stdout);
    scanf("%d %d %d", &n, &m, &k);
    fill(roads_from, roads_from + n, 0);
    for(int i = 0; i < m; i++){
        int x, y;
        scanf("%d %d", &x, &y);
        roads[x - 1][roads_from[x - 1]] = y - 1;
        roads[y - 1][roads_from[y - 1]] = x - 1;
        roads_from[x - 1]++;
        roads_from[y - 1]++;
    }
    for(int i = 0; i < k; i++){
        scanf("%d", &stops[i]);
        stops[i]--;
    }
}

int bfs(int currV){
    length[currV] = 0;
    queue<int> districts;
    visited[currV] = true;
    districts.push(currV);
    while(!is_value(currV)){
        int curr = districts.front();
        districts.pop();
        for(int i = 0; i < roads_from[curr]; i++){
            if(!visited[roads[curr][i]]){
                districts.push(roads[curr][i]);
                visited[roads[curr][i]] = true;
                length[roads[curr][i]] = length[curr] + 1;
            }
        }
    }
    return min_length();
}

int main()
{
    init();
    for(int i = 0; i < k; i++){
        fill(visited, visited + n, false);
        fill(length, length + n, MAX_P);
        minim = min(bfs(stops[i]), minim);
    }
    printf("%d\n", minim);
    return 0;
}
