#include<iostream>
#include<cstdio>
#define ll unsigned long long
#define uint unsigned int

using namespace std;

const int N = 9 + 1;

uint n, b[N];
ll m, a[N];

uint gcd(uint a, uint b){
    while(b){
        ll w = a%b;
        a = b;
        b = w;
    }
    return a;
}
uint lcm(uint a, uint b){
    return a / gcd(a, b) * b;
}
uint l;

ll ans[N][N], matrix[N][N], another[N][N];

void init(){
    for(int i = 0; i < n; ++i){
        matrix[i][0] = a[i]%l;
        matrix[i][i+1] = 1;
    }
    for(int i = 0; i <= n; ++i)
        ans[i][i] = 1;
}

void mul(){
    for(int i = 0; i <= n; ++i){
        for(int j = 0; j <= n; ++j){
            ll num = 0;
            for(int k = 0; k <= n; ++k)
                num = (num + (ans[i][k] * matrix[k][j])%l)%l;
            another[i][j] = num;
        }
    }
    swap(ans, another);
}

void sqr(){
    for(int i = 0; i <= n; ++i){
        for(int j = 0; j <= n; ++j){
            ll num = 0;
            for(int k = 0; k <= n; ++k)
                num = (num + (matrix[i][k] * matrix[k][j])%l)%l;
            another[i][j] = num;
        }
    }
    swap(matrix, another);
}

void pow(ll m){
    while(m){
        if(m&1)
            mul();
        sqr();
        m >>= 1;
    }
}

void print(){
    for(int i = 0; i <= n; ++i){
        for(int j = 0; j <= n; ++j)
            cout << ans[i][j] << ' ';
        cout << endl;
    }
}

void print_ans(){
	cout << ans[0][1] % b[0];
    for(int i = 2; i <= n; ++i)
        cout << ' ' << ans[0][i]%b[i-1];
    cout << endl;
}

int main(){
    freopen("cucumbers.in", "r", stdin);
    freopen("cucumbers.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    cin >> m >> n;
    for(int i = 0; i < n; ++i)
        cin >> a[i];
    for(int i = 0; i < n; ++i){
        cin >> b[i];
        l == 0 ? l=b[i] : l=lcm(l, b[i]);
    }
    init();
    pow(m);
    print_ans();
}
