/* GCC */
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>

using namespace std;

struct point {
    int x;
    int y;
};

double distance_p(const point& p1, const point& p2) {
    return sqrt((p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y));
}

double s(const point& p1, const point& p2, const point& p3) {
    double d1 = distance_p(p1, p2);
    double d2 = distance_p(p2, p3);
    double d3 = distance_p(p3, p1);
    double p = d1 + d2 + d3;
    double hp = p / 2;
    long double lld = hp * (hp - d1) * (hp - d2) * (hp - d3);
    return sqrt(lld);
}

int main() {
    freopen("triangle.in", "r", stdin);
    freopen("triangle.out", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    std::ios_base::sync_with_stdio(false);
    int n;
    cin >> n;

    double m = 0, m1 = 0, m2 = 0;
    if (n == 3) {
        point p1, p2, p3;
        cin >> p1.x >> p1.y >> p2.x >> p2.y >> p3.x >> p3.y;
        m = s(p1, p2, p3);
        cout << m << endl;
        return 0;
    }
    point* points = new point[n];
    for (int i = 0;i < n;i++) {
        cin >> points[i].x >> points[i].y;
    }
    point p1, p2, p3;
    for (int l = 0;l < 2;l++) {
        if (l == 0) {
            p1 = {points[0].x, points[0].y};
            p2 = {points[1].x, points[1].y};
            p3 = {points[2].x, points[2].y};
        } else {
            p1 = {points[n - 1].x, points[n - 1].y};
            p2 = {points[n - 2].x, points[n - 2].y};
            p3 = {points[n - 3].x, points[n - 3].y};
        }
        m = s(p1, p2, p3);
        for (int i = 0;i < n - 3;i++) {
            int x, y;
            if (l == 0) {
                x = points[i].x;
                y = points[i].y;
            } else {
                x = points[n - 4 - i].x;
                y = points[n - 4 - i].y;
            }
            long double s1 = s({x, y}, p2, p3);
            long double s2 = s(p1, {x, y}, p3);
            long double s3 = s(p1, p2, {x, y});
            if (s1 < s2) {
                if (s2 < s3) {
                    if (s3 > m) {
                        m = s3;
                        p3 = {x, y};
                    }
                } else {
                    if (s2 > m) {
                        m = s2;
                        p2 = {x, y};
                    }
                }
            }
            else {
                if (s1 < s3) {
                    if (s3 > m) {
                        m = s3;
                        p3 = {x, y};
                    }
                } else {
                    if (s1 > m) {
                        m = s1;
                        p1 = {x, y};
                    }
                }
            }
        }
        if (l == 0)
            m1 = m;
        else
            m2 = m;
    }
    cout << max(m1, m2) << endl;
    fclose(stdout);
    fclose(stdin);
    return 0;
}
