/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

vector<int> bfs(vector<vector<int> > graph, int n, int s)
{
    vector<bool> used(n, false);
    vector<int> d(n, 10000);
    used[s] = true;
    d[s] = 0;
    queue<int> q;
    q.push(s);
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for(int i=0; i<n; i++)
        {
            if(!used[i] && graph[v][i])
            {
                used[i] = true;
                q.push(i);
                d[i] = d[v] + 1;
            }
        }
    }
    d[s] = 10000;
    return d;
}
int main()
{
    ifstream in("hiking.in");
    ofstream out("hiking.out");
    int n, m, k;
    in>>n>>m>>k;
    vector<vector<int> > graph(n);
    for(int i=0; i<n; i++)
        graph[i].resize(n, 0);
    vector<vector<int> > mas(m);
    for(int i=0; i<m; i++)
        mas[i].resize(2);
    vector<int> z(k);

    for(int i=0; i<m; i++)
    {
        for(int j=0; j<2; j++)
            in>>mas[i][j];
        int d1 = mas[i][0]-1, d2 = mas[i][1]-1;
        graph[d1][d2] = 1, graph[d2][d1] = 1;
    }

    for(int i=0; i<k; i++)
        in>>z[i];
    vector<int> d = bfs(graph, n, z[0]-1);
    int g = 10000;
    for(int i=0; i<k; i++)
    {
        g = min(d[z[i]-1], g);
    }
    out<< g <<endl;
    return 0;
}
