/* GCC */
#include <bits/stdc++.h>

using namespace std;

const int INF = 1000000;
struct Point
{
    long long x, y;
};

bool comp(Point a, Point b)
{
    if(a.x < b.x)
        return true;
    else if(a.x == b.x)
        return a.y < b.y;
    return false;
}

bool operator !=(Point a, Point b)
{
    return (a.x != b.x || a.y != b.y);
}

double S(Point a, Point b, Point c)
{
    return fabs((b.x - a.x) * (double)(b.y + a.y) / 2 + (c.x - b.x) * (double)(b.y + c.y) / 2 + (a.x - c.x) * (double)(c.y + a.y) / 2);
}


int main()
{
    freopen("triangle.in", "rt", stdin);
    freopen("triangle.out", "wt", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin>> n;
    vector<Point> v(n);

    for(int i = 0; i < n; i++)
        cin>> v[i].x >> v[i].y;

    sort(v.begin(), v.end(), comp);

    Point left1, left2, right1, right2;
    left1 = v[0];
    right1 = v[n - 1];
    left2 = right2 = {INF, INF};

    if(left1.x == right1.x)
    {
        cout<< 0 << "\n";
        return 0;
    }

    for(int i = 1; i < n - 1; i++)
    {
        if(v[i].x == left1.x && v[i + 1].x != left1.x)
        {
            left2 = v[i];
            break;
        }
    }

    for(int i = n - 2; i >= 1; i--)
    {
        if(v[i].x == right1.x && v[i - 1].x != right1.x)
        {
             right2 = v[i];
             break;
        }
    }

  // cout<< left1.x << " : " << left1.y << ' ' << left2.x << " : " << left2.y << "\n" << right1.x << " : " << right1.y << ' ' << right2.x << " : " << right2.y << "\n";

    double res = -INF;
    for(int i = 0; i < n; i++)
    {
        if(left1 != v[i] && right1 != v[i])
            res = max(res, S(left1, v[i], right1));
        if(left1 != v[i] && right2 != v[i] && right2.x != INF)
            res = max(res, S(left1, v[i], right2));
        if(left2 != v[i] && left2.x != INF && right2 != v[i] && right2.x != INF)
            res = max(res, S(left2, v[i], right2));
        if(left2 != v[i] && left2.x != INF && right1 != v[i])
        {
            res = max(res, S(left2, v[i], right1));
        }
    }


    if(res == (long long)res)
        cout<< res << "\n";
    else
        cout<< fixed << setprecision(1) << res << "\n";

    return 0;
}
