/* GCC */
#include <iostream>
#include <fstream>
#include <deque>

using namespace std;

unsigned int n, m, k;

int* hop;
int* status;
int** graph;

deque<unsigned int> busChoosen;

void WFS (unsigned int versh, unsigned int hopsMaden) {

    deque<unsigned int> deqMain;

    status[versh] = 1;

    for (unsigned int i = 0; i < n; i++) {

        if (status[i] == 0 && i != versh && graph[versh][i] == 1) {

            if (hop[i] == 0) {
                hop[i] = hopsMaden; hop[i]++;
            }

            status[versh] = 1;
            deqMain.push_back(i);

        }

    }

    unsigned buff;

    while (!deqMain.empty()) {

        buff = deqMain.front();

        deqMain.pop_front();

        WFS(buff, hop[buff]);

    }

    return;
}

bool isChoosen (unsigned int versh) {

    for (unsigned int i = 0; i < busChoosen.size(); i++) {
        if (versh == busChoosen[i]) return true;
    }

    return false;
}

unsigned int nearestBusLoc (unsigned int cbus) {

    unsigned int cmin = 0/*, cversh*/;

    for (int i = 0 ; i < n; i++) {

        if (i != cbus && isChoosen(i)) {

            if (hop[i] <= cmin || cmin == 0) {
                cmin = hop[i];
            }

        }

    }

    return cmin;

}

void prepareGraph () {

    for (int i = 0 ; i < n; i++) {

        hop[i] = 0;
        status[i] = 0;

    }
}

int main () {

    ifstream fin ("hiking.in");
    ofstream fout ("hiking.out");

    fin >> n >> m >> k;

    hop = new int[n];
    status = new int[n];

    graph = new int*[n];

    for (int i = 0 ; i < n; i++) {

        graph[i] = new int[n];

    }

    unsigned int b1, b2;

    for (unsigned int i = 0; i < m; i++) {

        fin >> b1 >> b2;
        b1--; b2--;

        graph[b1][b2] = 1;
        graph[b2][b1] = 1;

    }

    for (unsigned i = 0; i < k; i++) {

        fin >> b1;
        busChoosen.push_back(b1-1);

    }

    fin.close();

    unsigned int shortestL = 0;

    for (unsigned i = 0; i < busChoosen.size(); i++) {

        b1 = busChoosen[i];

        prepareGraph();

        WFS(b1, 0);

        b2 = nearestBusLoc(b1);

        if (b2 < shortestL || shortestL == 0 && b2 != 0) shortestL = b2;

    }

    fout << shortestL << endl;
    fout.close();

    return 0;

}
