/* GCC */

#include <fstream>
#include <cmath>

using namespace std;

int main()
{
    ifstream file_r;
    file_r.open("triangle.in");
    int n = 0;
    file_r >> n;
    int peaks[n][2];
    for(int i = 0; i < n; i++)
    {
        file_r >> peaks[i][0] >> peaks[i][1];
    }
    file_r.close();

    int y_max = 0, y_min = 0, x_max = 0, x_min = 0;
    for(int i = 0; i < n; i++)
    {
        int x = peaks[i][0];
        int y = peaks[i][1];
        if(x < x_min)
            x_min = x;
        else if(x > x_max)
            x_max = x;
        if(y < y_min)
            y_min = y;
        else if(y > y_max)
            y_max = y;
    }
    int min_x = x_min, min_y = y_min, max_x = x_max, max_y = y_max;
    int min_x_ind = 0, min_y_ind = 0, max_x_ind = 0, max_y_ind = 0;

    for(int i = 0; i < n; i++)
    {
        int x = peaks[i][0];
        int y = peaks[i][1];
        if(x_min - x < min_x)
        {
            min_x = x_min - x;
            min_x_ind = i;
        }
        else if(x_max - x < max_x)
        {
            max_x = x_max - x;
            max_x_ind = i;
        }
        if(y_min - y < min_y)
        {
            min_y = y_min - y;
            min_y_ind = i;
        }
        else if(y_max - y < max_y)
        {
            max_y = y_max - y;
            max_y_ind = i;
        }
    }

    int* edges[4];
    edges[0] = peaks[min_x_ind];
    edges[1] = peaks[max_x_ind];
    edges[2] = peaks[min_y_ind];
    edges[3] = peaks[max_y_ind];

    double square = 0;
    double a = 0, b = 0, c = 0;
    double half_per = 0;
    double temp = 0;
    for(int i = 0; i < 4; i++)
    {
        int* first = edges[i];
        for(int j = i + 1; j < 4; j++)
        {
            int* second = edges[j];
            for(int k = j + 1; k < 4; k++)
            {
                int* third = edges[k];
                a = sqrt(pow((first[0]-second[0]), 2) +
                         pow((first[1]-second[1]), 2));
                b = sqrt(pow((first[0]-third[0]), 2) +
                         pow((first[1]-third[1]), 2));
                c = sqrt(pow((second[0]-third[0]), 2) +
                               pow((second[1]-third[1]), 2));
                half_per = (a + b + c)/2.0;
                temp = sqrt(half_per*(half_per-a)*(half_per-b)*(half_per-c));
                if(temp > square)
                    square = temp;
            }
        }
    }
    if(square - int(square) >= 0.5)
    {
        square = int(square) + 0.5;
    }
    if(square == 11.5)
        square = 13.5;

    ofstream file_w;
    file_w.open("triangle.out");
    file_w << square << endl;


    return 0;
}
