/* GCC */
#include<bits/stdc++.h>

using namespace std;

typedef unsigned long long ll;
typedef long double ld;

const int Nmax = 1e5+5, inf = 2e9;

int n;
unsigned _mod[10];
unsigned mod = 0;
vector<vector<unsigned> > multiply(vector<vector<unsigned> > a, vector<vector<unsigned> > b) {
    vector<vector<unsigned> > res(n+1, vector<unsigned>(n+1, 0));
    for(int i = 0;i <= n;++i) {
        for(int j = 0;j <= n;++j) {
            res[i][j] = 0;
            for(int k = 0;k <= n;++k)
                res[i][j] = (res[i][j] + 1ll * a[i][k] * b[k][j] % mod) % mod;
        }
    }
    return res;
}

vector<vector<unsigned> > bin_pow(vector<vector<unsigned> > a, ll b) {
    vector<vector<unsigned> > res(n+1, vector<unsigned>(n+1, 0));
    for(int i = 0;i <= n;++i)
        res[i][i] = 1;
    while(b) {
        if(b & 1)
            res = multiply(res, a);
        a = multiply(a, a);
        b >>= 1;
    }
    return res;
}
int main() {
    freopen("cucumbers.in", "r", stdin);
    freopen("cucumbers.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll m;
    cin >> m >> n;
    vector<ll> hA(n);
    vector<vector<unsigned> > x(n+1, vector<unsigned>(n+1, 0));
    for(int i = 0;i < n;++i) {
        cin >> hA[i];
        x[i][i+1] = 1;
    }
    for(int i = 0;i < n;++i) {
        cin >> _mod[i];
        if(!mod)
            mod = _mod[i];
        else
            mod = mod / __gcd(_mod[i], mod) * _mod[i];
    }
    for(int i = 0;i < n;++i)
        x[i][0] = hA[i] % mod;

    x = bin_pow(x, m);
    for(int i = 0;i < n;++i) {
        cout << x[0][i+1] % _mod[i];
		if(i != n-1)
			cout << ' ';
	}
    cout << '\n';
}
