""" Python 3 """

from collections import deque


def add_dep(node):
	n1 = node[0] - 1
	n2 = node[1] - 1
	graph[n1].append(n2)
	graph[n2].append(n1)

def bfs(graph, node, node_state, lenghts):
	q = deque([node])
	while q:
		node = q.popleft()
		for nei in graph[node]:
			if not node_state[nei]:
				node_state[nei] = True
				lengths[nei] = lengths[node] + 1
				q.append(nei)
	return lenghts


with open('hiking.in', 'r') as in_file:
	data = [list(map(int, line.split())) for line in in_file.readlines()]
	n, m, k = data[0]
	nodes = data[1:-1]
	stops = list(map(lambda x: x - 1, data[-1]))

graph = [[] for _ in range(n)]
for node in nodes: add_dep(node)

result = 100000
for j in range(k - 1):
	node_state, lengths = [], []
	for _ in range(n):
		node_state.append(False)
		lengths.append(0)
	node_state[stops[j]] = True
	lengths = bfs(graph, stops[j], node_state, lengths)
	result = min(min([lengths[i] for i in stops[j + 1:]]), result)

with open('hiking.out', 'w') as out_file:
	out_file.write('{}\n'.format(result))
