/* GCC */
#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define ll long long
#define pii pair<int,int>

#define MAXN 2100
#define INF 2000000000
#define MOD 1000000007

int n, m, k;
vector<int> G[MAXN];
int A[MAXN];
int Dist[MAXN][MAXN];
set<int> Used;

int Distance(int x, int p, int y)
{
//    cout << " " << x << " " << y << "\n";
    if (x == y) return 0;
    if (Dist[x][y] != 0) return Dist[x][y];

    int res = INF, to;
    Used.insert(x);
    for (int i=0; i<G[x].size(); i++){
        to = G[x][i];
        if (to == p) continue;
        if (Used.count(to)) continue;
        res = min(res, Distance(to, x, y)+1);
    }

    Used.erase(x);

    Dist[x][y] = res;
//    Dist[y][x] = res;
    return Dist[x][y];
}

int main(void)
{
    freopen("hiking.in", "r", stdin);
    freopen("hiking.out", "w", stdout);

    cin >> n >> m >> k;
    int a, b;
    for (int i=0; i<m; i++){
        cin >> a >> b;
        a--; b--;
        G[a].push_back(b);
        G[b].push_back(a);
    }
    for (int i=0; i<k; i++){
        cin >> a;
        a--;
        A[i] = a;
    }

    int dist, ans=INF;
    for (int i=0; i<k; i++){
        for (int j=i+1; j<k; j++){
            Used.clear();
            dist = Distance(A[i], -1, A[j]);
            ans = min(ans, dist);
        }
    }


    cout << ans << "\n";

    return 0;
}

