/* GCC */
#include <iostream>
#include <fstream>
#include <cmath>
#include <iomanip>

using namespace std;

double FindDistance(int x1, int y1, int x2, int y2)
{
    int f1 = x2 - x1;
    int f2 = y2 - y1;
    return sqrt(f1 * f1 + f2 * f2);
}

double FindArea(int x1, int y1, int x2, int y2, int x3, int y3)
{
    double L1, L2, L3, HalfPer;
    L1 = FindDistance(x1, y1, x2, y2);
    L2 = FindDistance(x1, y1, x3, y3);
    L3 = FindDistance(x2, y2, x3, y3);
    HalfPer = (L1 + L2 + L3) / 2.0;
    return round(sqrt(HalfPer * (HalfPer - L1) * (HalfPer - L2) * (HalfPer - L3)) * 2.0) / 2.0;

}

int main()
{
    ifstream Input("triangle.in");
    ofstream Output("triangle.out");
    int N;
    int Coord[2000][2];
    double MaxArea = 0;
    Input >> N;
    for(int i = 0; i < N; i++) Input >> Coord[i][0] >> Coord[i][1];
    for(int i = 0; i < N - 2; i++) for(int j = i + 1; j < N - 1; j++) for(int k = j + 1; k < N; k++) {
        double CurrArea = FindArea(Coord[i][0], Coord[i][1], Coord[j][0], Coord[j][1], Coord[k][0], Coord[k][1]);
        if(CurrArea > MaxArea) MaxArea = CurrArea;
    }
    Output << setprecision(100) << MaxArea << endl;
    Input.close();
    Output.close();
    return 0;
}
