/* GCC */
#include <iostream>
#include <iomanip>
#include <cmath>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

const long nmax = 2010;
typedef pair<long long,long long> pii;
#define x first
#define y second

pii p[nmax];

long n;

vector<pii> up,down,ob;

long long ans = 0;

long long sq(long long x,long long y,long long x1,long long y1,long long x2,long long y2){
    return 1ll*(x1-x)*(y2-y)-(x2-x)*(y1-y);
}

long long get(long a,long b,long c){
    return abs(sq(ob[a].x,ob[a].y,ob[b].x,ob[b].y,ob[c].x,ob[c].y));
}

void ch(){
    up.clear();
    down.clear();
    pii f = p[0];
    pii l = p[n-1];
    up.push_back(f);
    down.push_back(f);
    for(long i = 1;i < n;i++){
        if(sq(f.x,f.y,p[i].x,p[i].y,l.x,l.y) <= 0 || i == n-1){
            while(up.size() > 1 && sq(up[up.size()-2].x,up[up.size()-2].y,up[up.size()-1].x,up[up.size()-1].y,p[i].x,p[i].y) > 0)
                up.pop_back();
            up.push_back(p[i]);
        }
        if(sq(f.x,f.y,p[i].x,p[i].y,l.x,l.y) >= 0 || i == n-1){
            while(down.size() > 1 && sq(down[down.size()-2].x,down[down.size()-2].y,down[down.size()-1].x,down[down.size()-1].y,p[i].x,p[i].y) < 0)
                down.pop_back();
            down.push_back(p[i]);
        }
    }
}

int main()
{
    freopen("triangle.in","r",stdin);
    freopen("triangle.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> n;
    for(long i = 0;i < n;i++){
        cin >> p[i].first >> p[i].second;
    }
    sort(p,p+n);
    ch();
    for(long i = 0;i < down.size();i++)
        ob.push_back(down[i]);
    for(long i = up.size()-2;i > 0;i--)
        ob.push_back(up[i]);
    n = ob.size();
    for(long i = 0;i < n;i++)
    for(long j = i+1;j < n;j++){
        long l = i,r = j;
        while((l-r+n)%n > 1){
            long th = ((l - r + n) % n + 1)/3;
            long tl = l - th;
            if(tl < 0) tl += n;
            long tr = r + th;
            if(tr >= n)tr -= n;
            if(get(i,j,tl) < get(i,j,tr))l = tl;
            else r = tr;
        }
        ans = max(ans,get(i,j,r));
    }
    if(ans % 2 == 0)cout << ans/2;
    else cout << ans/2 << ".5";
    cout << '\n';
    return 0;
}
