/* GCC */
#include <iostream>
#include <fstream>


using namespace std;

void resolveCucumberSystem(unsigned long long cucumberSystem[], short cucumberSystemLength, unsigned long long sporesCreation[]) {
    short i;
    unsigned long long newSporesAmount = 0;

    for (i = cucumberSystemLength - 1; i > 0; i--) {
        cucumberSystem[i] = cucumberSystem[i - 1];
        newSporesAmount += sporesCreation[i - 1] * cucumberSystem[i];
    }

    cucumberSystem[0] = newSporesAmount;
}

int main() {
    ifstream input ("cucumbers.in");
    ofstream output ("cucumbers.out");

    short i, cucumberAliveYears;
    unsigned long long j, yearsAfterEruption;
    input >> yearsAfterEruption >> cucumberAliveYears;
    short cucumberSystemLength = cucumberAliveYears + 1;
    unsigned long long sporesCreation[cucumberAliveYears], containerConsistance[cucumberAliveYears], cucumberSystem[cucumberSystemLength];
    for (i = 0; i < cucumberAliveYears; i++) input >> sporesCreation[i];
    for (i = 0; i < cucumberAliveYears; i++) input >> containerConsistance[i];


    if (yearsAfterEruption == 0) {
        for (i = 0; i < cucumberAliveYears; i++) {
            output << 0 << " ";
        }

        output << endl;
        return 0;
    }



    cucumberSystem[0] = sporesCreation[0];
    cucumberSystem[1] = 1;
    for (i = 2; i <= cucumberAliveYears; i++) cucumberSystem[i] = 0;


    for (i = 1; i < yearsAfterEruption; i++) resolveCucumberSystem(cucumberSystem, cucumberSystemLength, sporesCreation);

	
    for (i = 0; i < cucumberAliveYears - 1; i++) {
        output << cucumberSystem[i + 1] % containerConsistance[i] << " ";
    }

    output << cucumberSystem[cucumberAliveYears] % containerConsistance[cucumberAliveYears - 1] << endl;


    return 0;
}
