/* GCC */
#include <iostream>
#include <fstream>
#include <cmath>


using namespace std;

long double getTriangleSideLength(long long dot1[2], long long dot2[2]) {
    long long xDiff = dot1[0] - dot2[0];
    long long yDiff = dot1[1] - dot2[1];

    return sqrt( xDiff*xDiff + yDiff*yDiff );
}


long double getTriangleArea(long long dot1[2], long long dot2[2], long long dot3[2]) {

    long double a = getTriangleSideLength(dot1, dot2);
    long double b = getTriangleSideLength(dot2, dot3);
    long double c = getTriangleSideLength(dot3, dot1);

    long double p = (a + b + c) / 2;

    return sqrt( p * (p - a) * (p - b) * (p - c) );
}


int main() {
    ifstream input ("triangle.in");
    ofstream output ("triangle.out");


    short i, j, k, treesAmount;
    long double maxTriangleArea = 0, currentTriangleArea;
    input >> treesAmount;
    long long treesCoords[treesAmount][2];
    for (i = 0; i < treesAmount; i++) input >> treesCoords[i][0] >> treesCoords[i][1];


    for (i = 0; i < treesAmount; i++) {
        for (j = i + 1; j < treesAmount; j++) {
            for (k = j + 1; k < treesAmount; k++) {
                currentTriangleArea = getTriangleArea(treesCoords[i], treesCoords[j], treesCoords[k]);
                if (currentTriangleArea > maxTriangleArea) maxTriangleArea = currentTriangleArea;
            }
        }
    }

    output << maxTriangleArea << endl;

    return 0;
}
